// Copyright (c) [2024] SUSE LLC
//
// All Rights Reserved.
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, contact SUSE LLC.
//
// To contact SUSE LLC about this file by physical or electronic mail, you may
// find current contact information at www.suse.com.

//! # DBus interface proxy for: `org.opensuse.Agama1.Registration`
//!
//! This code was generated by `zbus-xmlgen` `3.1.1` from DBus introspection data.
use zbus::dbus_proxy;

#[dbus_proxy(
    interface = "org.opensuse.Agama1.Registration",
    default_service = "org.opensuse.Agama.Software1",
    default_path = "/org/opensuse/Agama/Software1/Product"
)]
trait Registration {
    /// Deregister method
    fn deregister(&self) -> zbus::Result<(u32, String)>;

    /// Register method
    fn register(
        &self,
        reg_code: &str,
        options: std::collections::HashMap<&str, zbus::zvariant::Value<'_>>,
    ) -> zbus::Result<(u32, String)>;

    /// Email property
    #[dbus_proxy(property)]
    fn email(&self) -> zbus::Result<String>;

    /// RegCode property
    #[dbus_proxy(property)]
    fn reg_code(&self) -> zbus::Result<String>;

    /// Requirement property
    #[dbus_proxy(property)]
    fn requirement(&self) -> zbus::Result<u32>;
}
